=== debian/changelog ===
gdal (3.6.4+dfsg-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 11 Jun 2023 10:31:40 +0200

gdal (3.6.4+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 21 Apr 2023 15:19:16 +0200

gdal (3.6.4~rc1+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop spelling-errors2.patch, applied upstream.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 17 Apr 2023 14:23:20 +0200

gdal (3.6.3+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 14 Mar 2023 05:22:49 +0100

gdal (3.6.3~rc1+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Bump Standards-Version to 4.6.2, no changes.
  * Drop files removed upstream from Files-Excluded.
  * Update symbols for amd64.
  * Update lintian overrides.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 07 Mar 2023 20:44:11 +0100
